#version 430
#extension GL_ARB_separate_shader_objects : enable










struct SComputeInput
{
	uvec3 GlobalThreadID; uvec3 LocalThreadID; uvec3 GroupID;};

layout( std140) uniform UCubemapData
{
	uint Face;
	uint Size;
} CubemapData;
 uniform samplerCube InputTextureCube;
 uniform writeonly image2D OutData;






void ComputeMain( in SComputeInput  cInput  )
{
	uint face =  CubemapData.Face ;
	uint size =  CubemapData.Size ;

	if (cInput.GlobalThreadID.x >= size || cInput.GlobalThreadID.y >= size) return;

	vec2 uv = vec2(1.0f, 1.0f) - (( vec2(cInput.GlobalThreadID.xy)  + vec2(0.5, 0.5)) /  float(size) );
	uv = uv * 2.0f - 1.0f;

	vec3 DArr[6] =
	{
		vec3(1, uv.y, uv.x),
		vec3(-1, uv.y, -uv.x),
		vec3(-uv.x, 1, -uv.y),
		vec3(-uv.x, -1, uv.y),
		vec3(-uv.x, uv.y, 1),
		vec3(uv.x, uv.y, -1)
	};

	vec3 D = normalize(DArr[face]);


	D.x = -D.x;

	vec3 col = vec3(0, 0, 0);







	col =  textureLod(InputTextureCube, D, 0.0f) .rgb;





	col = min(col, vec3(100, 100, 100));

	imageStore(OutData, ivec2(cInput.GlobalThreadID.xy), vec4(col, 1.0f)) ;

}


layout(local_size_x = 32, local_size_y = 32, local_size_z = 1) in;
void main()
{
	SComputeInput cInput;
	cInput.GlobalThreadID = gl_GlobalInvocationID;
	cInput.LocalThreadID = gl_LocalInvocationID;
	cInput.GroupID = gl_WorkGroupID;
	ComputeMain(cInput);
}
