#version 430
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) in vec3 _vin_Position;

struct SVertexInput
{
	vec3 Position;
	int VertexIndex;
	uint InstanceId;
};

layout(location = 0) smooth out vec4 _vout_fragColor;

struct SVertexOutput
{
	vec4 fragColor;
	vec4 VertexPosition;
};

layout( std140) uniform USceneInfo
{
	mat4 ViewProj;
	mat4 View;
	mat4 Proj;
	mat4 InvView;
	mat4 InvViewProj;
	mat4 UserToLHZ;
	mat4 LHZToUser;
	mat4 BillboardingView;
	mat4 PackNormalView;
	mat4 UnpackNormalView;
	vec4 SideVector;
	vec4 DepthVector;
	vec2 ZBufferLimits;
	vec2 ViewportSize;
	float Handedness;
} SceneInfo;
layout(std430 ) readonly buffer BMeshTransformsOffsets
{
	uint MeshTransformsOffsets[];
} MeshTransformsOffsets;
layout(std430 ) readonly buffer BIndirectionOffsets
{
	uint IndirectionOffsets[];
} IndirectionOffsets;
layout(std430 ) readonly buffer BColorsOffsets
{
	uint ColorsOffsets[];
} ColorsOffsets;
layout(std430 ) readonly buffer BGPUSimData
{
	uint GPUSimData[];
} GPUSimData;
layout(std430 ) readonly buffer BMeshTransforms
{
	uint MeshTransforms[];
} MeshTransforms;
layout(std430 ) readonly buffer BIndirection
{
	uint Indirection[];
} Indirection;

layout( std140) uniform UGPUMeshPushConstants
{
	uint DrawRequest;
	uint IndirectionOffsetsIndex;
} GPUMeshPushConstants;


mat4 GetMeshMatrix( in SVertexInput  vInput  )
{

	const uint storageID =  GPUMeshPushConstants.DrawRequest ;
	const uint indirectionOffsetsID =  GPUMeshPushConstants.IndirectionOffsetsIndex ;
	const uint indirectionOffset =  IndirectionOffsets.IndirectionOffsets [ indirectionOffsetsID ] ;
	const uint transformsOffset =  MeshTransformsOffsets.MeshTransformsOffsets [ storageID ] ;
	const uint particleID =  Indirection.Indirection [indirectionOffset + vInput.InstanceId ] ;
	const vec4 m0 =  vec4( uintBitsToFloat(MeshTransforms.MeshTransforms [transformsOffset + particleID * 16 + 0 * 4 ]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 0 * 4 ) + 1]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 0 * 4 ) + 2]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 0 * 4 ) + 3]) ) ;
	const vec4 m1 =  vec4( uintBitsToFloat(MeshTransforms.MeshTransforms [transformsOffset + particleID * 16 + 1 * 4 ]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 1 * 4 ) + 1]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 1 * 4 ) + 2]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 1 * 4 ) + 3]) ) ;
	const vec4 m2 =  vec4( uintBitsToFloat(MeshTransforms.MeshTransforms [transformsOffset + particleID * 16 + 2 * 4 ]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 2 * 4 ) + 1]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 2 * 4 ) + 2]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 2 * 4 ) + 3]) ) ;
	const vec4 m3 =  vec4( uintBitsToFloat(MeshTransforms.MeshTransforms [transformsOffset + particleID * 16 + 3 * 4 ]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 3 * 4 ) + 1]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 3 * 4 ) + 2]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 3 * 4 ) + 3]) ) ;
	return  mat4(m0, m1, m2, m3) ;
}



void VertexMain( in SVertexInput  vInput,  out SVertexOutput  vOutput  )
{
		const uint storageID =  GPUMeshPushConstants.DrawRequest ;
		const uint indirectionOffsetsID =  GPUMeshPushConstants.IndirectionOffsetsIndex ;
		const uint indirectionOffset =  IndirectionOffsets.IndirectionOffsets [ indirectionOffsetsID ] ;
		const uint transformsOffset =  MeshTransformsOffsets.MeshTransformsOffsets [ storageID ] ;
		const uint particleID =  Indirection.Indirection [indirectionOffset + vInput.InstanceId ] ;
		const vec4 m0 =  vec4( uintBitsToFloat(MeshTransforms.MeshTransforms [transformsOffset + particleID * 16 + 0 * 4 ]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 0 * 4 ) + 1]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 0 * 4 ) + 2]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 0 * 4 ) + 3]) ) ;
		const vec4 m1 =  vec4( uintBitsToFloat(MeshTransforms.MeshTransforms [transformsOffset + particleID * 16 + 1 * 4 ]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 1 * 4 ) + 1]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 1 * 4 ) + 2]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 1 * 4 ) + 3]) ) ;
		const vec4 m2 =  vec4( uintBitsToFloat(MeshTransforms.MeshTransforms [transformsOffset + particleID * 16 + 2 * 4 ]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 2 * 4 ) + 1]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 2 * 4 ) + 2]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 2 * 4 ) + 3]) ) ;
		const vec4 m3 =  vec4( uintBitsToFloat(MeshTransforms.MeshTransforms [transformsOffset + particleID * 16 + 3 * 4 ]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 3 * 4 ) + 1]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 3 * 4 ) + 2]) , uintBitsToFloat(MeshTransforms.MeshTransforms [(transformsOffset + particleID * 16 + 3 * 4 ) + 3]) ) ;
		const mat4 modelMatrix =  mat4(m0, m1, m2, m3) ;

		vec4 pos =  ((modelMatrix) * (vec4(vInput.Position, 1.0))) ;
		vOutput.VertexPosition =  (( SceneInfo.ViewProj ) * (pos)) ;


		vOutput.fragColor =  vec4( uintBitsToFloat(GPUSimData.GPUSimData [ ColorsOffsets.ColorsOffsets [ storageID ] + particleID * 4 ]) , uintBitsToFloat(GPUSimData.GPUSimData [( ColorsOffsets.ColorsOffsets [ storageID ] + particleID * 4 ) + 1]) , uintBitsToFloat(GPUSimData.GPUSimData [( ColorsOffsets.ColorsOffsets [ storageID ] + particleID * 4 ) + 2]) , uintBitsToFloat(GPUSimData.GPUSimData [( ColorsOffsets.ColorsOffsets [ storageID ] + particleID * 4 ) + 3]) ) ;
}


void main()
{
	SVertexInput vInput;
	SVertexOutput vOutput;

	vInput.Position = _vin_Position;
	vInput.VertexIndex = gl_VertexID;
	vInput.InstanceId = uint(gl_InstanceID);
	vOutput.fragColor = vec4(0, 0, 0, 0);
	VertexMain(vInput, vOutput);
	_vout_fragColor = vOutput.fragColor;
	gl_Position = vOutput.VertexPosition;
}
