#version 430
#extension GL_ARB_separate_shader_objects : enable










struct SComputeInput
{
	uvec3 GlobalThreadID; uvec3 LocalThreadID; uvec3 GroupID;};

layout(std430 ) readonly buffer BIndirectBuffer
{
	uint IndirectBuffer[];
} IndirectBuffer;
layout(std430 ) buffer BOutIndirectionOffsets
{
	uint OutIndirectionOffsets[];
} OutIndirectionOffsets;

layout( std140) uniform UInfo
{
	uint DrawCallCount;
} Info;



void ComputeMain( in SComputeInput  cInput  )
{
	const uint drawCallID = cInput.GlobalThreadID.x;
	const uint targetDrawCallID = cInput.GlobalThreadID.y;
	const uint drawCallCount =  Info.DrawCallCount ;

	if (drawCallID >= drawCallCount - 1 || targetDrawCallID >= drawCallCount || targetDrawCallID <= drawCallID)
		return;







	const uint drawIndirectArgsId = drawCallID;

	const uint drawCallParticleCount =  IndirectBuffer.IndirectBuffer [ drawIndirectArgsId * 5 + 1 ] ;



	uint dummyOutput;
	dummyOutput = atomicAdd( OutIndirectionOffsets.OutIndirectionOffsets [ targetDrawCallID ], floatBitsToUint(drawCallParticleCount * 4) ) ;
	dummyOutput = atomicAdd( OutIndirectionOffsets.OutIndirectionOffsets [ drawCallCount + targetDrawCallID ], floatBitsToUint(drawCallParticleCount * 4) ) ;


}

layout(local_size_x = 32, local_size_y = 32, local_size_z = 1) in;
void main()
{
	SComputeInput cInput;
	cInput.GlobalThreadID = gl_GlobalInvocationID;
	cInput.LocalThreadID = gl_LocalInvocationID;
	cInput.GroupID = gl_WorkGroupID;
	ComputeMain(cInput);
}
