#version 330
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) smooth in vec4 _fin_fragColor0;
layout(location = 1) smooth in vec4 _fin_fragColor1;
layout(location = 2) smooth in vec4 _fin_fragColor2;
layout(location = 3) smooth in vec4 _fin_fragNodeExtendedPixelCoord;
layout(location = 4) smooth in vec4 _fin_fragNodePixelCoord;

struct SFragmentInput
{
	vec4 fragColor0;
	vec4 fragColor1;
	vec4 fragColor2;
	vec4 fragNodeExtendedPixelCoord;
	vec4 fragNodePixelCoord;
	bool IsFrontFace;
};

layout(location = 0) out vec4 _fout_outColor;

struct SFragmentOutput
{
	vec4 outColor;
};






void FragmentMain( in SFragmentInput  fInput,  out SFragmentOutput  fOutput  )
{
	{


		float dashSize = ceil(fInput.fragNodePixelCoord.w * 0.2f);
		int dashFrequency = 3;
		float coord = fInput.fragNodePixelCoord.x + fInput.fragNodePixelCoord.y;


		vec4 colDashCur = (int((coord + 0.0f) / dashSize) % dashFrequency == 0) ? fInput.fragColor0 : fInput.fragColor1;
		vec4 colDashPos = (int((coord + 0.5f) / dashSize) % dashFrequency == 0) ? fInput.fragColor0 : fInput.fragColor1;
		vec4 colDashNeg = (int((coord - 0.5f) / dashSize) % dashFrequency == 0) ? fInput.fragColor0 : fInput.fragColor1;
		fOutput.outColor = (colDashCur + colDashPos + colDashNeg) * (1.0f / 3.0f);
	}
}


void main()
{
	SFragmentInput fInput;
	SFragmentOutput fOutput;

	fInput.fragColor0 = _fin_fragColor0;
	fInput.fragColor1 = _fin_fragColor1;
	fInput.fragColor2 = _fin_fragColor2;
	fInput.fragNodeExtendedPixelCoord = _fin_fragNodeExtendedPixelCoord;
	fInput.fragNodePixelCoord = _fin_fragNodePixelCoord;
	fInput.IsFrontFace = gl_FrontFacing;
	FragmentMain(fInput, fOutput);
	_fout_outColor = fOutput.outColor;
}
